// Xds.cpp: implementation of the CXds class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "AecMfc32TimeCode.h"
#include "Xds.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CCodeType::CCodeType()
{
	
	Zero();
	bHasText = false;
}

CCodeType::~CCodeType()
{

}

BOOL CCodeType::Add(char c1, char c2)
{
	int i;
	int cks;

	if (c1 < 0x0F)
	{
		m_code = c1;
		m_type = c2;
		index = 0;
	}
	//put the char1/char2 at the "index" of 
	s_full[index++] = c1;
	s_full[index++] = c2;

	
	//bDone = false;
	if (c1 == 0x0F)	//END
	{
		bLoading = false;	//we got the last two bytes just now and are done?
		cks = 0;	//init checksum
		for (i=0; i<index; i++)	//check the checksum
		{
			cks += 	s_full[i];
		}
		if ((cks & 0x7F) == 0x00)	//we have a zero checksum? (yes = done OK)		
			bDone = true;		
		else Zero();	//error saving
	}
	else bLoading = true;
	return bDone;
}

void CCodeType::Zero()
{
	index = 0;
	bLoading = false;
	bDone = false;
	
}

BOOL CCodeType::Done()
{
	return bDone;
}

BOOL CCodeType::Loading()
{
	return bLoading;
}


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CXds::CXds()
{
	i_code = 5;
	i_type = 0;
}

CXds::~CXds()
{

}

void CXds::Add(char c1, char c2)
{
//	int i, j;
	BOOL ok = false;;
//	BYTE m_code;
//	BYTE m_type;
//	mt x[5];
	
	switch (c1)
	{
		case 0x01:	//current start
				ok = x[0].y[(int)c2].Add(c1, c2);
		case 0x02:	//current continue
				i_code = 0;
				i_type = (int)c2;
			break;
		case 0x03:	//future  start
				ok = x[1].y[(int)c2].Add(c1, c2);
		case 0x04:	//future continue
				i_code = 1;
				i_type = (int)c2;
				break;
		case 0x05:	//channel start
				ok = x[2].y[(int)c2].Add(c1, c2);
		case 0x06:	//			continue
				i_code = 2;
				i_type = (int)c2;
				break;
		case 0x07:	//misc start
				ok = x[3].y[(int)c2].Add(c1, c2);
		case 0x08:	//		continue
				i_code = 3;
				i_type = (int)c2;
				break;
		case 0x09:	//Pub start
				ok = x[4].y[(int)c2].Add(c1, c2);
		case 0x0A:	//		continue
				i_code = 4;
				i_type = (int)c2;
				break;
		case 0x0B:	//Res start
		case 0x0C:	//		continue
				i_code = 5;
				i_type = (int)c2;
				break;
		case 0x0D:	//UnDef start
		case 0x0E:	//		continue
				i_code = 5;
				i_type = (int)c2;
				break;
		case 0x0F:	//End All			
				if (i_code < 5)	//don't process anything for Res/UnDef
					ok = x[i_code].y[i_type].Add(c1, c2);
				break;
		default:
				if (i_code < 5)	//don't process anything for Res/UnDef
					ok = x[i_code].y[i_type].Add(c1, c2);
				break;

	}

	if (ok)
	{
		//process and save "text message"
		SetText(i_code, i_type);
		x[i_code].y[i_type].bHasText = true;
	}	
}

//	BYTE	s_full[36];
//	BYTE	s_data[33];
//	BOOL	bLoading;
//	BOOL	bDone;
//	int		index;
//	BYTE	m_code;
//	BYTE`	m_type;
//	char	str[50];

char* CXds::ScreenData()
{
	int i, j;
	
	wsprintf (ScreenOutput, "\n");
	for (i = 0; i < 5; i++)
	{
		for (j = 0; j < 24; j++)
			//if (x[i].y[j].Done())	
			if (x[i].y[j].bHasText)
				strcat (ScreenOutput, x[i].y[j].Text);
	}
	return ScreenOutput;

}

void CXds::Init()
{
	int i, j;
	
	for (i = 0; i < 5; i++)
	{
		for (j = 0; j < 24; j++)
			if (x[i].y[j].Done())
			{
				x[i].y[j].Zero();
				x[i].y[j].bHasText = false;
			}
	}
	return;
}

void CXds::SetText(int i, int j)
{
	int iA, iB, iC, iD, iE, iF, k, m;
	BOOL b2, b3, bV, bL, bS, bD;
	char c;
	BYTE c1, c2, temp1, temp2, main, sap;
	char s[35];
	switch (i)
	{
		case 0:	//current
		case 1:	//future (same as current processing)
			switch (j)
			{
				case 0x01:	//Program ID# [min1-59][hr0-23][day1-31][month1-12]
					iA = (int)((x[i].y[j].s_full[2]) & 0x3F);	//min
					iB = (int)((x[i].y[j].s_full[3]) & 0x1F);	//hr
					iC = (int)((x[i].y[j].s_full[4]) & 0x1F);	//day
					iD = (int)((x[i].y[j].s_full[5]) & 0x0F);	//mo
					wsprintf (x[i].y[j].Text,"Program:Date&Time - %d/%d %d:%d \n",iD, iC, iB, iA);
					//wsprintf (x[i].y[j].Text,"Program:Date-Time %2.2X ",(BYTE) c);
					break;
				case 0x02:	//Len/time-in-show
					iA = (int)((x[i].y[j].s_full[2]) & 0x3F);	//min
					iB = (int)((x[i].y[j].s_full[3]) & 0x3F);	//hr
					//iC = ((x[i].y[j].s_full[4]) & 0x3F);	//ET min
					//iD = ((x[i].y[j].s_full[5]) & 0x3F);	//ET hr
					//iE = ((x[i].y[j].s_full[5]) & 0x3F);	//ET sec
					wsprintf (x[i].y[j].Text,"Program Length - %d:%d \n", iB, iA);
					break;
				case 0x03:
					k = 2;
					m = 0;
					do
					{
						c = (x[i].y[j].s_full[k] & 0x7F);
						if (c == 0x0F)
							break;
						else s[m++] = c;
						k++;
					} while (m < 32);
					s[m] = 0;	//NULL at end
					wsprintf (x[i].y[j].Text,"TITLE - ");
					strcat( x[i].y[j].Text, s );
					strcat( x[i].y[j].Text, "\n" );
					break;
				case 0x04:
					wsprintf (x[i].y[j].Text,"TYPE - ");
					k = 2;
					m = 0;
					do
					{
						c = (x[i].y[j].s_full[k] & 0x7F);
						if (c == 0x0F)
							break;
						else
						{
							switch (c)
							{
								case 0x20:
									wsprintf (s,"Education ");
									break;
								case 0x21:
									wsprintf (s,"Entertainment ");
									break;
								case 0x22:
									wsprintf (s,"Movie ");
									break;
								case 0x23:
									wsprintf (s,"News ");
									break;
								case 0x24:
									wsprintf (s,"Religious ");
									break;
								case 0x25:
									wsprintf (s,"Sports ");
									break;
								case 0x26:
									wsprintf (s,"OTHER ");
									break;
								default:
									wsprintf (s,"%2.2X ", (BYTE)c);
									break;
							}
							strcat( x[i].y[j].Text, s );
						}
						k++;
					} while (k < 34);
					strcat( x[i].y[j].Text, "\n" );
					break;
				case 0x05:
					c1 = (BYTE)((x[i].y[j].s_full[2]) & 0x7F);	//c1-x 1 D/a2 a1 a0   r2 r1 r0
					c2 = (BYTE)((x[i].y[j].s_full[3]) & 0x7F);	//c2-x 1 (F)V S  L/a3 g2 g1 g0
					wsprintf (x[i].y[j].Text,"RATING (%2.2X%2.2X) - ", c1, c2);

					temp1 = (c1 & 0x58);	//01011000
					switch (temp1)
					{
						case 0x40:	//01-0 0---		MPAA Sys0							
						case 0x50:	//01-1 0---		MPAA Sys2							
							temp2 = (c1 & 0x07);	//00000xxx
							switch (temp2)
							{
								case 0x00:
									strcat( x[i].y[j].Text, "MPAA N/A \n" );
									break;
								case 0x01:
									strcat( x[i].y[j].Text, "MPAA 'G' \n" );
									break;
								case 0x02:
									strcat( x[i].y[j].Text, "MPAA 'PG' \n" );
									break;
								case 0x03:
									strcat( x[i].y[j].Text, "MPAA 'PG-13' \n" );
									break;
								case 0x04:
									strcat( x[i].y[j].Text, "MPAA 'R' \n" );
									break;
								case 0x05:
									strcat( x[i].y[j].Text, "MPAA 'NC-17' \n" );
									break;
								case 0x06:
									strcat( x[i].y[j].Text, "MPAA 'X' \n" );
									break;
								default:
									strcat( x[i].y[j].Text, "MPAA Not Rated \n" );
									break;
							}
							break;
						case 0x48:	//01-0 1---		US TV Sys0						1
							temp2 = (c2 & 0x07);	//00000xxx
							bV = ((c2 & 0x20) ? true:false); //c2.5
							bS = ((c2 & 0x10) ? true:false); //c2.4
							bL = ((c2 & 0x08) ? true:false); //c2.3
							bD = ((c1 & 0x20) ? true:false); //c1.5
							switch (temp2)
							{
								case 0x00:
									strcat( x[i].y[j].Text, "US None" );
									break;
								case 0x01:
									strcat( x[i].y[j].Text, "US 'TV-Y'" );
									break;
								case 0x02:
									strcat( x[i].y[j].Text, "US 'TV-Y7'" );
									if (bV)
										strcat( x[i].y[j].Text, ", Fantasy Violence " );
									break;
								case 0x03:
									strcat( x[i].y[j].Text, "US 'TV-G'" );
									break;
								case 0x04:
									strcat( x[i].y[j].Text, "US 'TV-PG'" );
									if (bV)
										strcat( x[i].y[j].Text, ", Violence " );
									if (bS)
										strcat( x[i].y[j].Text, ", Sexual Situations " );
									if (bL)
										strcat( x[i].y[j].Text, ", Adult Language " );
									if (bD)
										strcat( x[i].y[j].Text, ", Sexually Suggestive Dialog " );
									break;
								case 0x05:
									strcat( x[i].y[j].Text, "US 'TV-14'" );
									if (bV)
										strcat( x[i].y[j].Text, ", Violence " );
									if (bS)
										strcat( x[i].y[j].Text, ", Sexual Situations " );
									if (bL)
										strcat( x[i].y[j].Text, ", Adult Language " );
									if (bD)
										strcat( x[i].y[j].Text, ", Sexually Suggestive Dialog " );
									break;
								case 0x06:
									strcat( x[i].y[j].Text, "US 'TV-MA'" );
									if (bV)
										strcat( x[i].y[j].Text, ", Violence " );
									if (bS)
										strcat( x[i].y[j].Text, ", Sexual Situations " );
									if (bL)
										strcat( x[i].y[j].Text, ", Adult Language " );
									break;
								default:
									strcat( x[i].y[j].Text, "US None " );
									break;
							}
							strcat( x[i].y[j].Text, " \n" );
							break;
						default:	//01-1 1---		MORE...							
							//c1.5 and c2.3
							b2 = ((c1 & 0x20) ? true:false);
							b3 = ((c2 & 0x08) ? true:false);
							if (b2 && b3)	//11 Sys 6 Reserved NON-US/CAN
							{
								strcat( x[i].y[j].Text, "NON-US/CAN-6 \n" );
							}
							else if (b3)	//10 Sys 5 Reserved NON-US/CAN
							{
								strcat( x[i].y[j].Text, "NON-US/CAN-5 \n" );
							}
							else if (b2)	//01 Sys 4 CANfrench
							{
								temp2 = (c1 & 0x07);	//00000xxx
								switch (temp2)
								{
									case 0x00:
										strcat( x[i].y[j].Text, "CANf 'E' \n" );
										break;
									case 0x01:
										strcat( x[i].y[j].Text, "CANf 'G' \n" );
										break;
									case 0x02:
										strcat( x[i].y[j].Text, "CANf '8 ans +' \n" );
										break;
									case 0x03:
										strcat( x[i].y[j].Text, "CANf '13 ans +' \n" );
										break;
									case 0x04:
										strcat( x[i].y[j].Text, "CANf '16 ans +' \n" );
										break;
									case 0x05:
										strcat( x[i].y[j].Text, "CANf '18 ans +' \n" );
										break;
									case 0x06:
										strcat( x[i].y[j].Text, "CANf -(110) \n" );
										break;
									default:
										strcat( x[i].y[j].Text, "CANf -(111) \n" );
										break;
								}
							}
							else			//00 Sys 3 CANenglish
							{
								temp2 = (c1 & 0x07);	//00000xxx
								switch (temp2)
								{
									case 0x00:
										strcat( x[i].y[j].Text, "CANe 'E' Exempt \n" );
										break;
									case 0x01:
										strcat( x[i].y[j].Text, "CANe 'C' Children \n" );
										break;
									case 0x02:
										strcat( x[i].y[j].Text, "CANe 'C8+' Children 8+yr \n" );
										break;
									case 0x03:
										strcat( x[i].y[j].Text, "CANe 'G' General, Suitable for all \n" );
										break;
									case 0x04:
										strcat( x[i].y[j].Text, "CANe 'PG' Parental Guidence \n" );
										break;
									case 0x05:
										strcat( x[i].y[j].Text, "CANe '14+' Viewers 14yr+ \n" );
										break;
									case 0x06:
										strcat( x[i].y[j].Text, "CANe '18+' Adult Programming \n" );
										break;
									default:
										strcat( x[i].y[j].Text, "CANe - (111)\n" );
										break;
								}
							}
							break;
					}							
					break;
				case 0x06:
					wsprintf (x[i].y[j].Text,"Audio Service - ");
					main = (BYTE)((x[i].y[j].s_full[2]) & 0x38);	//bits 6-3
					sap = (BYTE)((x[i].y[j].s_full[3]) & 0x38);		//bits 6-3
					temp1 = (BYTE)((x[i].y[j].s_full[2]) & 0x07);	//bits 2-0
					temp2 = (BYTE)((x[i].y[j].s_full[3]) & 0x07);	//bits 2-0

					switch (main)
					{
						strcat( x[i].y[j].Text, "Main: " );
						case 0x00:
							strcat( x[i].y[j].Text, "Unknown/" );
							break;
						case 0x08:
							strcat( x[i].y[j].Text, "English/" );
							break;
						case 0x10:
							strcat( x[i].y[j].Text, "Spanish/" );
							break;
						case 0x18:
							strcat( x[i].y[j].Text, "French/" );
							break;
						case 0x20:
							strcat( x[i].y[j].Text, "German/" );
							break;
						case 0x28:
							strcat( x[i].y[j].Text, "Italian/" );
							break;
						case 0x30:
							strcat( x[i].y[j].Text, "Other/" );
							break;
						default:
							strcat( x[i].y[j].Text, "None/" );
							break;
					}
					switch (temp1)
					{
						case 0x00:
							strcat( x[i].y[j].Text, "Unknown  " );
							break;
						case 0x08:
							strcat( x[i].y[j].Text, "Mono  " );
							break;
						case 0x10:
							strcat( x[i].y[j].Text, "Simulated Stereo  " );
							break;
						case 0x18:
							strcat( x[i].y[j].Text, "True Stereo  " );
							break;
						case 0x20:
							strcat( x[i].y[j].Text, "Stereo Surround  " );
							break;
						case 0x28:
							strcat( x[i].y[j].Text, "Data Service  " );
							break;
						case 0x30:
							strcat( x[i].y[j].Text, "Other  " );
							break;
						default:
							strcat( x[i].y[j].Text, "None  " );
							break;
					}


					switch (sap)
					{
						strcat( x[i].y[j].Text, "SAP: " );
						case 0x00:
							strcat( x[i].y[j].Text, "Unknown/" );
							break;
						case 0x08:
							strcat( x[i].y[j].Text, "English/" );
							break;
						case 0x10:
							strcat( x[i].y[j].Text, "Spanish/" );
							break;
						case 0x18:
							strcat( x[i].y[j].Text, "French/" );
							break;
						case 0x20:
							strcat( x[i].y[j].Text, "German/" );
							break;
						case 0x28:
							strcat( x[i].y[j].Text, "Italian/" );
							break;
						case 0x30:
							strcat( x[i].y[j].Text, "Other/" );
							break;
						default:
							strcat( x[i].y[j].Text, "None/" );
							break;
					}
					switch (temp2)
					{
						case 0x00:
							strcat( x[i].y[j].Text, "Unknown  " );
							break;
						case 0x08:
							strcat( x[i].y[j].Text, "Mono  " );
							break;
						case 0x10:
							strcat( x[i].y[j].Text, "Video Descriptions  " );
							break;
						case 0x18:
							strcat( x[i].y[j].Text, "Non-program Audio  " );
							break;
						case 0x20:
							strcat( x[i].y[j].Text, "Special Effects  " );
							break;
						case 0x28:
							strcat( x[i].y[j].Text, "Data Service  " );
							break;
						case 0x30:
							strcat( x[i].y[j].Text, "Other  " );
							break;
						default:
							strcat( x[i].y[j].Text, "None  " );
							break;
					}
					strcat( x[i].y[j].Text, "\n" );
					break;
				case 0x07:	//2-8 char
					wsprintf (x[i].y[j].Text,"Caption Services - ");
					k = 2;
					do
					{
						c1 = (BYTE)(x[i].y[j].s_full[k++]);	
						temp1 = (c1 & 0x38);	//bits 6-3
						temp2 = (c1 & 0x07);	//bits 2-0
						if (c1 == 0x0F)
							break;
						else
						{
							switch (temp1)
							{
								case 0x00:
									strcat( x[i].y[j].Text, "Unknown/" );
									CapsAvailable(i, j, temp2);
									break;
								case 0x08:
									strcat( x[i].y[j].Text, "English/" );
									CapsAvailable(i, j, temp2);
									break;
								case 0x10:
									strcat( x[i].y[j].Text, "Spanish/" );
									CapsAvailable(i, j, temp2);
									break;
								case 0x18:
									strcat( x[i].y[j].Text, "French/" );
									CapsAvailable(i, j, temp2);
									break;
								case 0x20:
									strcat( x[i].y[j].Text, "German/" );
									CapsAvailable(i, j, temp2);
									break;
								case 0x28:
									strcat( x[i].y[j].Text, "Italian/" );
									CapsAvailable(i, j, temp2);
									break;
								case 0x30:
									strcat( x[i].y[j].Text, "Other/" );
									CapsAvailable(i, j, temp2);
									break;
								default:
									strcat( x[i].y[j].Text, "None/" );
									CapsAvailable(i, j, temp2);
									break;
							}
						}
					} while (k < 10);

					strcat( x[i].y[j].Text, "\n" );
					break;
				case 0x08:
					wsprintf (x[i].y[j].Text,"08h \n");
					break;
				case 0x09:
					iA = (int)((x[i].y[j].s_full[2]) & 0x3F);	//min
					iB = (int)((x[i].y[j].s_full[3]) & 0x3F);	//hr

					wsprintf (x[i].y[j].Text,"Aspect Ratio - start:%d  end:%d \n", (iA+22), (262-iB));
					break;
				case 0x0A:
					wsprintf (x[i].y[j].Text,"0Ah \n");
					break;
				case 0x0B:
					wsprintf (x[i].y[j].Text,"0Bh \n");
					break;
				case 0x0C:
					wsprintf (x[i].y[j].Text,"Composite Packet-1 \n");
					break;
				case 0x0D:
					wsprintf (x[i].y[j].Text,"Composite Packet-2 \n");
					break;
				case 0x0E:
					wsprintf (x[i].y[j].Text,"0Eh \n");
					break;
				case 0x0F:
					wsprintf (x[i].y[j].Text,"0Fh \n");
					break;
				case 0x10:
					wsprintf (x[i].y[j].Text,"Desc10: ");
					StuffDescription(i, j);
					break;
				case 0x11:
					wsprintf (x[i].y[j].Text,"Desc11: ");
					StuffDescription(i, j);
					break;
				case 0x12:
					wsprintf (x[i].y[j].Text,"Desc12: ");
					StuffDescription(i, j);
					break;
				case 0x13:
					wsprintf (x[i].y[j].Text,"Desc13: ");
					StuffDescription(i, j);
					break;
				case 0x14:
					wsprintf (x[i].y[j].Text,"Desc14: ");
					StuffDescription(i, j);
					break;
				case 0x15:
					wsprintf (x[i].y[j].Text,"Desc15: ");
					StuffDescription(i, j);
					break;
				case 0x16:
					wsprintf (x[i].y[j].Text,"Desc16: ");
					StuffDescription(i, j);
					break;
				case 0x17:
					wsprintf (x[i].y[j].Text,"Desc17: ");
					StuffDescription(i, j);
					break;
				default:					
					wsprintf (x[i].y[j].Text," \n");
					break;
				}
					//??
			break;
		case 2:	//channel
			switch (j)
			{
				case 0x01:	//2-32 char
					wsprintf (x[i].y[j].Text,"NetName: ");
					StuffDescription(i, j);
					break;
				case 0x02:	//4-6 char
					wsprintf (x[i].y[j].Text,"StationID: ");
					StuffDescription(i, j);
					break;
				case 0x03:	//Program ID# [min1-59][hr0-23][day1-31][month1-12]
					iA = (int)((x[i].y[j].s_full[2]) & 0x3F);	//min
					iB = (int)((x[i].y[j].s_full[3]) & 0x1F);	//hr
					wsprintf (x[i].y[j].Text,"TapeDelay - %d:%d \n", iB, iA);
					break;
				default:					
					wsprintf (x[i].y[j].Text," \n");
					break;
			}
			break;

		case 3:	//misc
			switch (j)
			{
				case 0x01:	//6 char
					iA = (int)((x[i].y[j].s_full[2]) & 0x3F);	//min
					iB = (int)((x[i].y[j].s_full[3]) & 0x1F);	//hr
					iC = (int)((x[i].y[j].s_full[4]) & 0x1F);	//day
					iD = (int)((x[i].y[j].s_full[5]) & 0x0F);	//mo
					iE = (int)((x[i].y[j].s_full[5]) & 0x07);	//day of week, 1=Sunday
					iF = (int)((x[i].y[j].s_full[5]) & 0x3F);	//Yr = 1990 + (6 bit value)
					wsprintf (x[i].y[j].Text,"Date/Time: - %d/%d/%d %d:%d  ",iD, iC, (iF + 1990), iB, iA);
					DayOfWeek(i, j, iE);
					//wsprintf (x[i].y[j].Text,"Program:Date-Time %2.2X ",(BYTE) c);
					break;					
				case 0x02:	//6 char
					iA = (int)((x[i].y[j].s_full[2]) & 0x3F);	//min
					iB = (int)((x[i].y[j].s_full[3]) & 0x1F);	//hr
					iC = (int)((x[i].y[j].s_full[4]) & 0x1F);	//day
					iD = (int)((x[i].y[j].s_full[5]) & 0x0F);	//mo
					wsprintf (x[i].y[j].Text,"ImpulseCapture - %d/%d %d:%d ",iD, iC, iB, iA);					StuffDescription(i, j);
					iA = (int)((x[i].y[j].s_full[6]) & 0x3F);	//min
					iB = (int)((x[i].y[j].s_full[7]) & 0x3F);	//hr					
					wsprintf (s, " Length = %d:%d \n", iB, iA);
					strcat (x[i].y[j].Text, s);
					break;
				case 0x03:	
					iA = (int)((x[i].y[j].s_full[2]) & 0x3F);	//min
					//iB = (int)((x[i].y[j].s_full[3]) & 0x1F);	//hr
					wsprintf (x[i].y[j].Text,"Supplemental Data %d \n", iA);
					break;
				case 0x04:	//Program ID# [min1-59][hr0-23][day1-31][month1-12]
					iA = (int)((x[i].y[j].s_full[2]) & 0x1F);	//min
					//DST not dealt with here (bit 5)
					wsprintf (x[i].y[j].Text,"Local Time Zone & DST - %d \n", iA);
					break;
				default:					
					//??
					//40h, Out-of-Band Channel Number... Note handled
					wsprintf (x[i].y[j].Text," \n");
					break;
			}
			break;
		case 4:	//Pub
			switch (j)
			{
				case 0x01:	//6 char
					wsprintf (x[i].y[j].Text,"Weather (WRSAME) - ");
					StuffDescription(i, j);
					break;					
				case 0x02:	//6 char
					wsprintf (x[i].y[j].Text,"Weather Message - ");
					StuffDescription(i, j);
					break;
				default:					
					//??
					//40h, Out-of-Band Channel Number... Note handled
					wsprintf (x[i].y[j].Text," \n");
					break;
			}

			break;
		default:
			break;

	}
}

void CXds::CapsAvailable(int ii, int jj, BYTE fct)
{
	switch (fct)
	{
		case 0x00:
			strcat( x[ii].y[jj].Text, "F1CC1 " );
			break;
		case 0x08:
			strcat( x[ii].y[jj].Text, "F1TXT1 " );
			break;
		case 0x10:
			strcat( x[ii].y[jj].Text, "F1CC2 " );
			break;
		case 0x18:
			strcat( x[ii].y[jj].Text, "F1TXT2 " );
			break;
		case 0x20:
			strcat( x[ii].y[jj].Text, "F2TXT1 " );
			break;
		case 0x28:
			strcat( x[ii].y[jj].Text, "F2TXT1 " );
			break;
		case 0x30:
			strcat( x[ii].y[jj].Text, "F2CC2 " );
			break;
		default:
			strcat( x[ii].y[jj].Text, "F2TXT2 " );
			break;
	}
	return;
}

void CXds::StuffDescription(int ii, int jj)
{
	int k, m;
	char c;
	char s[35];
	k = 2;
	m = 0;
	do
	{
		c = (x[ii].y[jj].s_full[k] & 0x7F);
		if (c == 0)
			s[m++] = '0';	//put zero at NULL just for the heck of it (cause it could be?)
		else if (c < 0x20)
			break;
		else s[m++] = c;
		k++;
	} while (k < 34);
	s[m] = 0;	//NULL at end
	strcat( x[ii].y[jj].Text, s );
	strcat( x[ii].y[jj].Text, "\n" );
	return;
}

void CXds::DayOfWeek(int ii, int jj, int dow)
{
	switch (dow)
	{
		case 0x01:
			strcat( x[ii].y[jj].Text, "Sunday \n " );
			break;
		case 0x02:
			strcat( x[ii].y[jj].Text, "Monday \n " );
			break;
		case 0x03:
			strcat( x[ii].y[jj].Text, "Tuesday \n " );
			break;
		case 0x04:
			strcat( x[ii].y[jj].Text, "Wednesday \n " );
			break;
		case 0x05:
			strcat( x[ii].y[jj].Text, "Thursday \n " );
			break;
		case 0x06:
			strcat( x[ii].y[jj].Text, "Friday \n " );
			break;
		case 0x07:
			strcat( x[ii].y[jj].Text, "Saturday \n " );
			break;
		default:
			strcat( x[ii].y[jj].Text, " \n " );
			break;
	}
	return;
}

